#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "share_string.h"

// convention: use type name_t for strings returned from find_word
typedef char * name_t;
typedef struct FriendList * friend_lst_t;
typedef struct PeopleList * people_lst_t;
typedef struct Person     * person_t;

// YOUR CODE HERE

void print_friends(people_lst_t pl) {
  printf("\n");
  for(; pl != NULL; pl = pl->tail) {
    printf("%s:", pl->p.name);
    friend_lst_t friends;
    for(friends = pl->p.friends; friends != NULL; friends = friends->tail)
      printf(" %s", friends->friend->name);
    printf("\n");
  }
}

int main(int argc, char** argv) {
  if(argc != 2) {
    fprintf(stderr,"usage: %s filename\n",argv[0]);
    return 1;
  }
  FILE * f = fopen(argv[1],"r");
  if(!f) {
    fprintf(stderr,"unable to open %s\n",argv[1]);
    return 1;
  }
  print_friends(get_friends(f));
  return 0;
}
