#ifndef SHARE_STRING_H
#define SHARE_STRING_H

typedef struct WordCache * words_t;

// create word-cache, suitable for using with find_word below
words_t new_word_cache();

// also frees the words; if you want to keep the strings, just call free
// with the words_t pointer.
void free_cache(words_t); 

// find_word returns a '\0'-terminated string that is n+1 characters long 
// (including the '\0').
// s should have at least n non-'\0' characters; the returned string
// will have ith character s[i] for 0 <= i <= (n-1).
//
// Furthermore, for the same word-cache, two calls with the same n and
// with strings that have the first n characters in common are guaranteed
// to have the same (pointer-equal) result.
//
// find_word heap-allocates space for the strings it returns.
char * find_word(words_t w, char * s, int n);

#endif
